package ru.ulstu.extractor.ts;

import ru.ulstu.extractor.model.TimeSeriesValue;
import ru.ulstu.extractor.service.TimeSeriesService;

import java.util.List;

public abstract class AbstractTimeSeriesCreator {

    public abstract String getTimeSeriesName();

    public abstract List<TimeSeriesValue> getTimeSeriesValues(Integer repositoryId, String branchName);

    public abstract TimeSeriesService getTimeSeriesService();

    public void addTimeSeries(Integer repositoryId, String branchName) {
        getTimeSeriesService().save(
                String.format("%s %s %s", getTimeSeriesName(), repositoryId, branchName),
                TimeSeriesDateMapper.mapTimeSeriesToInterval(getTimeSeriesService().getTimeSeriesInterval(),
                        getTimeSeriesValues(repositoryId, branchName)));
    }
}
