package ru.ulstu.extractor.ts;

import org.springframework.stereotype.Component;
import ru.ulstu.extractor.commit.service.CommitService;
import ru.ulstu.extractor.model.TimeSeriesValue;
import ru.ulstu.extractor.service.TimeSeriesService;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class CommitsTS extends AbstractTimeSeriesCreator {
    private final TimeSeriesService timeSeriesService;
    private final CommitService commitService;

    public CommitsTS(TimeSeriesService timeSeriesService,
                     CommitService commitService) {
        this.timeSeriesService = timeSeriesService;
        this.commitService = commitService;
    }

    @Override
    public String getTimeSeriesName() {
        return "Количество коммитов во времени";
    }

    @Override
    public List<TimeSeriesValue> getTimeSeriesValues(Integer repositoryId, String branchName) {
        //TODO: добавить постраничное чтение
        return commitService.findByRepositoryIdAndName(repositoryId, branchName)
                .stream()
                .map(c -> new TimeSeriesValue(c.getDate(), 1))
                .collect(Collectors.toList());
    }

    @Override
    public TimeSeriesService getTimeSeriesService() {
        return timeSeriesService;
    }
}
